Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java	(revision 1299)
@@ -1,7 +1,9 @@
 package example.energy.coolemall;
 
+import schedframe.resources.computing.Node;
 import schedframe.resources.computing.coolemall.ComputeBox1;
 import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -21,5 +23,14 @@
 			}
 		}
-		powerConsumption = (powerConsumption + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION)/CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY;
+		
+		int nrOfPoweredOffNodes = 0;
+		for(Node node: computeBox1.getNodes()){
+			if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF)){
+				nrOfPoweredOffNodes++;
+			}
+		}
+		if(nrOfPoweredOffNodes != computeBox1.getNodes().size()){
+			powerConsumption = (powerConsumption + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION)/CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY;			
+		}
 		return powerConsumption;
 	}
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java	(revision 1299)
@@ -4,36 +4,14 @@
 
 	//HARDWARE
-	public static final double SINGLE_FAN_ON_AIR_FLOW = 0.0112;
-	public static final double SINGLE_FAN_OFF_AIR_FLOW = 0;
+	//public static final double SINGLE_FAN_ON_AIR_FLOW = 0.0112;
+	//public static final double SINGLE_FAN_OFF_AIR_FLOW = 0;
 	
-	public static final double SINGLE_FAN_ON_POWER_CONSUMPTION = 6;
-	public static final double SINGLE_FAN_OFF_POWER_CONSUMPTION = 0;
+	//public static final double SINGLE_FAN_ON_POWER_CONSUMPTION = 0;
+	//public static final double SINGLE_FAN_OFF_POWER_CONSUMPTION = 0;
 	
-	public static final double OTHER_DEVICES_POWER_CONSUMPTION = 775;
+	public static final double OTHER_DEVICES_POWER_CONSUMPTION = 0;
 	
 	public static final double POWER_SUPPLY_EFFICIENCY = 0.87;
 	
 
-	public static final int Atom_D510_NR_OF_THREADS = 2;
-	
-	public static final int Atom_N2600_NR_OF_THREADS = 2;
-	
-	public static final int Core_i7_2715QE_NR_OF_THREADS = 4;
-	
-	public static final int Core_i7_3615QE_NR_OF_THREADS = 4;
-	
-	public static final int Fusion_G_T40N_NR_OF_THREADS = 2;
-	
-	//APPLICATIONS
-	public static final double Atom_D510 = 336.3;
-	
-	public static final double Atom_N2600 = 336.3;
-	
-	public static final double Core_i7_2715QE = 3076.4;
-	
-	public static final double Core_i7_3615QE = 3786.0;
-	
-	public static final double Fusion_G_T40N = 649.3;
-	
-
 }
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java	(revision 1299)
@@ -1,5 +1,11 @@
 package example.energy.coolemall;
 
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.coolemall.ComputeBox1;
+import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.devices.Device;
+import schedframe.resources.devices.Fan;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -12,27 +18,68 @@
 			PhysicalResource resource) {
 		
+		/*********** Pfans_dc ***********/
 		double powerConsumption = 0;
+		double nf = 0.6;
+		
+		double delta_p;//from database, CFD
+		double Vair_total;
+		
+		delta_p = ConfigurationOptions.coolingData.getPressureDrop();
+		Vair_total = ConfigurationOptions.coolingData.getAirFlowVolume();
+		
+		if(delta_p != -1 && Vair_total != -1)
+			powerConsumption = delta_p * Vair_total / nf;
+		else {
+			Device flowPump = (Device) resource;
+			ComputingResource room = flowPump.getComputingResource();
+			
+			double ro = 1.168;//constant
+		
+			double mair_total;
+			
+			//in case of DCworms calculation of Vair_total
+			double mair_rack = 0;
 
-		double nf = 0.6;
+			for(ComputingResource cr: room.getChildren()){
+				ComputeBox1 cb1 = (ComputeBox1)cr;
+				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
+					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Outlet)){
+							
+							Fan fan = (Fan) device;
+							double mair_recs = 0;
+							double Vair_recs = 0;
+							
+							double Vair_recs1 = 0;
 
-		double delta_p;//from database, CFD
-		try{
-			delta_p = ConfigurationOptions.pressureDrop;
-		} catch (Exception e){
-			delta_p = 0;
+							Vair_recs1  = fan.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+							double Vair_recs2 = 0;
+							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
+								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){
+
+									Vair_recs2  = device2.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+									break;
+								}
+							}	
+
+							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
+
+							mair_recs = Vair_recs * ro;
+							mair_rack  = mair_rack + mair_recs;
+						}
+					}
+				}
+			}
+			mair_total = mair_rack;
+			Vair_total = mair_total / ro;
+			
+
+			if(delta_p != -1 && Vair_total != -1)
+				powerConsumption = delta_p * Vair_total / nf;
 		}
 		
-		double Vair_total;
-		
-		try{
-			Vair_total = ConfigurationOptions.airFlowVolume;
-		} catch (Exception e){
-			Vair_total = 0;
-		}
-
-		
-		//if data not present in DB than don't take Pfans_dc into account
-		if(delta_p != -1 && Vair_total != -1)
-			powerConsumption = delta_p * Vair_total / nf;
+		//System.out.println("Flow Pump power: " + powerConsumption);
 		
 		return powerConsumption;
@@ -43,12 +90,54 @@
 		double Vair_total;
 		
-		try{
-			Vair_total = ConfigurationOptions.airFlowVolume;
-		} catch (Exception e){
-			Vair_total = 0;
+		Vair_total = ConfigurationOptions.coolingData.getAirFlowVolume();
+		if(Vair_total != -1) {
+			airThroughput = Vair_total;
+		} else {
+			Device flowPump = (Device) resource;
+			ComputingResource room = flowPump.getComputingResource();
+
+			double ro = 1.168;//constant
+			
+			double mair_total;
+			double mair_rack = 0;
+
+			for(ComputingResource cr: room.getChildren()){
+				ComputeBox1 cb1 = (ComputeBox1)cr;
+				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
+					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Outlet)){
+							
+							Fan fan = (Fan) device;
+							double mair_recs = 0;
+							double Vair_recs = 0;
+							
+							double Vair_recs1 = 0;
+
+							Vair_recs1  = fan.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+							double Vair_recs2 = 0;
+							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
+								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){
+
+									Vair_recs2  = device2.getAirThroughputInterface().getRecentAirFlow().getValue();
+
+									break;
+								}
+							}	
+
+							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);
+
+							mair_recs = Vair_recs * ro;
+							mair_rack  = mair_rack + mair_recs;
+						}
+					}
+				}
+			}
+			mair_total = mair_rack;
+			Vair_total = mair_total / ro;
+			airThroughput = Vair_total;
 		}
-		airThroughput = Vair_total;
 		return airThroughput;
 	}
-
+	
 }
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java	(revision 1253)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java	(revision 1299)
@@ -1,4 +1,6 @@
 package example.energy.coolemall;
 
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Node;
 import schedframe.resources.computing.Processor;
@@ -6,14 +8,11 @@
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 import schedframe.resources.devices.Device;
+import schedframe.resources.devices.Fan;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
-import test.Node_Fan_Mapping;
 import example.energy.BaseEnergyEstimationPlugin;
 
 public class NodeEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {
 
-	//private static int OUT_START_ID = 0;
-	//private static int OUT_END_ID = 8;
-	
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
 			PhysicalResource resource) {
@@ -30,86 +29,36 @@
 			//powerConsumption = powerConsumption + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
 			for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
-				if(device.getFullName().equals(Node_Fan_Mapping.getNode_fan().get(node.getFullName()))){
-					if(device.getPowerInterface().getRecentPowerUsage().getValue() == -1){
-						powerConsumption = powerConsumption + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
-					}else
-						powerConsumption = powerConsumption + device.getPowerInterface().getRecentPowerUsage().getValue();
-					break;
+				if(device.getType().equals(StandardResourceType.Fan) || device.getType().equals(StandardResourceType.Inlet) | device.getType().equals(StandardResourceType.Outlet)){
+					Fan fan = (Fan) device;
+					if(fan.getChilledResources().contains(node.getFullName())){
+						if(fan.getPowerInterface().getRecentPowerUsage().getValue() == -1){
+							try {
+								powerConsumption = powerConsumption + fan.getAirThroughputInterface().getPowerConsumption(fan.getAirThroughputInterface().getAirThroughputState())/getNumberOfWorkingNodes(fan);
+							} catch (NoSuchFieldException e) {
+								// TODO Auto-generated catch block
+								e.printStackTrace();
+							}
+						}else
+							powerConsumption = powerConsumption + fan.getPowerInterface().getRecentPowerUsage().getValue()/getNumberOfWorkingNodes(fan);
+					}
 				}
 			}
 		} 
 
-
 		return powerConsumption;
 	}
-
-	/*public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
-
-		double airThroughput = 0;
-		try {
-			if(event.getReason() == EventReason.SIM_INIT)
-				return airThroughput;
-				//airThroughput = resource.getAirThroughputInterface().getAirFlow(StandardAirThroughputStateName.FAN_OFF);
-			else {
-				airThroughput = resource.getAirThroughputInterface().getAirFlow(resource.getAirThroughputInterface().getAirThroughputState());
-				//airThroughput = computingResource.getResourceCharacteristic().getDevices().get(0).getAirThroughputInterface().getAirFlow(resource.getAirThroughputInterface().getAirThroughputState());
-				//airThroughput = 0.28;
-			}
-		} catch (NoSuchFieldException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
-		
-		//Integer resId = Integer.parseInt(resource.getName().split("_")[1]);
-		//ComputingResource computingResource = (ComputingResource) resource;
-		//we estimate the air flow related to the outlets (nodes placed in the outlet row of RECS)
-		//if(resId >= OUT_START_ID  && resId <= OUT_END_ID){
-		//	for(ComputingResource compResource: computingResource.getParent().getChildren()){
-		//		Integer id = Integer.parseInt(compResource.getName().split("_")[1]);
-		//		//we take into account the inlet air flow (nodes placed "behind" the given node)
-		//		if(id - resId == 9 || id - resId == -9){
-		//			try {
-		//				airThroughput = airThroughput + compResource.getAirThroughputInterface().getAirFlow(compResource.getAirThroughputInterface().getAirThroughputState())/2;
-		//			} catch (NoSuchFieldException e) {
-		//
-		//			}
-		//		}
-		//	}
-		//}
-
-		return airThroughput;
-	}*/
-
-	/*public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
-		double tout = 0;
-		double tin = 21.3;
-		double Q = 0.0056085;
-		double C = 1004;
-		double delta1 = 1.780594389/2;
-		double delta2 = 2.162043729/2;
-		double ro = 1.168;
-		double power1 = 0;
-		double power2 = 0;
-		
-		Integer resId = Integer.parseInt(resource.getName().split("_")[1]);
-		
-		ComputingResource computingResource = (ComputingResource) resource;
-		
-		//we estimate outlet temperature (related to the temperature of the nodes placed in outlet row)
-		for(ComputingResource compResource: computingResource.getParent().getChildren()){
-			Integer id = Integer.parseInt(compResource.getName().split("_")[1]);
-			//we take into account the power of nodes placed "behind" the given nodes
-			if(id - resId == 9){
-				power1 = compResource.getPowerInterface().getRecentPowerUsage().getValue();
-				power2 = resource.getPowerInterface().getRecentPowerUsage().getValue();
-			} else if(id - resId == -9){
-				power1 = resource.getPowerInterface().getRecentPowerUsage().getValue();
-				power2 = compResource.getPowerInterface().getRecentPowerUsage().getValue();
+	
+	
+	private int getNumberOfWorkingNodes(Device device){
+		int quantity = 0;
+		Fan fan = (Fan) device;
+		for(ComputingResource compRes: device.getComputingResource().getChildren()){
+			Node node = (Node)compRes;
+			if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.ON) && fan.getChilledResources().contains(node.getFullName())){
+				quantity++;
 			}
 		}
-		
-		tout = tin + delta1 * (power1/(Q * C * ro)) +  delta2 * (power2/(Q * C * ro));;
-		return tout;
-	}*/
-	
+		return quantity;
+	}
+
 }
